package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.digests.SHA1Digest;
import cn.com.infosec.crypto.params.DSAParameters;
import cn.com.infosec.crypto.params.DSAValidationParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class DSAParametersGenerator {
   private static final BigInteger ONE = BigInteger.valueOf(1L);
   private static final BigInteger TWO = BigInteger.valueOf(2L);
   private int size;
   private int certainty;
   private SecureRandom random;

   private void add(byte[] a, byte[] b, int value) {
      int var10001 = (b[b.length - 1] & 255) + value;
      int var10003 = (b[b.length - 1] & 255) + value;
      int var4 = b.length - 1;
      a[var4] = (byte)var10003;
      var4 = var10001 >>> 8;

      for(value = b.length - 2; value >= 0; --value) {
         int var10000 = var4 += b[value] & 255;
         a[value] = (byte)var4;
         var4 = var10000 >>> 8;
      }

   }

   public void init(int size, int certainty, SecureRandom random) {
      this.size = size;
      this.certainty = certainty;
      this.random = random;
   }

   public DSAParameters generateParameters() {
      byte var1 = 20;
      byte[] var2 = new byte[20];
      int var3 = 20;
      byte[] var4 = new byte[20];
      byte var5 = 20;
      byte[] var6 = new byte[20];
      byte var7 = 20;
      byte[] var8 = new byte[20];
      SHA1Digest var9;
      var9 = new SHA1Digest.<init>();
      int var10000 = this.size;
      int var10 = (var10000 - 1) / 160;
      int var11;
      byte[] var12 = new byte[var11 = var10000 / 8];
      BigInteger var13 = null;
      BigInteger var14 = null;
      int var15 = 0;
      boolean var16 = false;

      while(true) {
         BigInteger var24;
         while(!var16) {
            do {
               this.random.nextBytes(var2);
               var9.update(var2, 0, var1);
               var9.doFinal(var4, 0);
               System.arraycopy(var2, 0, var6, 0, var1);
               this.add(var6, var2, 1);
               var9.update(var6, 0, var5);
               var9.doFinal(var6, 0);

               for(int var22 = 0; var22 != var7; ++var22) {
                  var8[var22] = (byte)(var4[var22] ^ var6[var22]);
               }

               var8[0] |= -128;
               var8[19] = (byte)(var8[19] | 1);
               var24 = var13 = new BigInteger;
               var13.<init>(1, var8);
            } while(!var24.isProbablePrime(this.certainty));

            var15 = 0;

            for(int var17 = 2; var15 < 4096; var17 += var10 + 1) {
               int var23 = 0;

               while(var23 < var10) {
                  this.add(var4, var2, var17 + var23);
                  var9.update(var4, 0, var3);
                  var9.doFinal(var4, 0);
                  int var18 = var11 - ++var23 * var3;
                  System.arraycopy(var4, 0, var12, var18, var3);
               }

               this.add(var4, var2, var17 + var10);
               var9.update(var4, 0, var3);
               var9.doFinal(var4, 0);
               System.arraycopy(var4, var3 - (var23 = var11 - var10 * var3), var12, 0, var23);
               var12[0] |= -128;
               var24 = new BigInteger(1, var12);
               if ((var14 = var24.subtract(var24.mod(var13.multiply(TWO)).subtract(ONE))).testBit(this.size - 1) && var14.isProbablePrime(this.certainty)) {
                  var16 = true;
                  break;
               }

               ++var15;
            }
         }

         BigInteger var25 = var14.subtract(ONE).divide(var13);

         BigInteger var20;
         BigInteger var21;
         do {
            do {
               var24 = var20 = new BigInteger;
               var3 = this.size;
               var24.<init>(var3, this.random);
            } while(var24.compareTo(var21 = ONE) <= 0);
         } while(var20.compareTo(var14.subtract(var21)) >= 0 || (var20 = var20.modPow(var25, var14)).compareTo(var21) <= 0);

         DSAValidationParameters var19;
         var19 = new DSAValidationParameters.<init>(var2, var15);
         return new DSAParameters(var14, var13, var20, var19);
      }
   }
}
